/*

Copyright (C) 2012  Observatoire de Paris

The JavaScript code in this page is free software: you can
redistribute it and/or modify it under the terms of the GNU
General Public License (GNU GPL) as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.  The code is distributed WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.

As additional permission under GNU GPL version 3 section 7, you
may distribute non-source (e.g., minimized or compacted) forms of
that code without the copy of the GNU GPL normally required by
section 4, provided you include this license notice and a URL
through which recipients can access the Corresponding Source.

*/

function FiltreDlg(fct_suite) {
    var that;
    
    this.fct_suite = fct_suite;
    this.dim = 3; // doit être un nombre impair
    this.tf = null;
    this.filtre = [[1, 2, 1], [2, 4, 2], [1, 2, 1]];
    
    that = this;
    this.proxyAnnulation = function(e) { that.annuler(); };
    this.proxyValidation = function(e) { e.preventDefault(); that.valider(); return(false); };
}

FiltreDlg.prototype.afficher = function() {
    var div, h2, p, formulaire, table, tr, td, input, i, j, div_boutons, bannuler, bok, div_overlay;
    
    div = document.getElementById('div-filtre');
    if (div.firstChild == null) {
        h2 = document.createElement('h2');
        h2.appendChild(document.createTextNode(Messages.get("Filtre")));
        div.appendChild(h2);
        
        p = document.createElement('p');
        p.appendChild(document.createTextNode(Messages.get("Valeurs_filtre")));
        div.appendChild(p);
        
        formulaire = document.createElement('form');
        formulaire.setAttribute('autocomplete', 'off');
        formulaire.addEventListener('submit', this.proxyValidation, false);
        table = document.createElement('table');
        tf = Traitement.tableau2D(this.dim, this.dim);
        for (j=0; j<this.dim; j++) {
            tr = document.createElement('tr');
            for (i=0; i<this.dim; i++) {
                td = document.createElement('td');
                input = document.createElement('input');
                input.setAttribute('type', 'text');
                input.setAttribute('size', '5');
                input.setAttribute('value', '' + this.filtre[i][j]);
                tf[i][j] = input;
                td.appendChild(input);
                tr.appendChild(td);
            }
            table.appendChild(tr);
        }
        formulaire.appendChild(table);
        
        div_boutons = document.createElement('div');
        div_boutons.setAttribute('id', 'div-boutons');
        
        bannuler = document.createElement('button');
        bannuler.setAttribute('id', 'annuler');
        bannuler.setAttribute('type', 'button');
        bannuler.appendChild(document.createTextNode(Messages.get("Annuler")));
        bannuler.addEventListener('click', this.proxyAnnulation, false);
        div_boutons.appendChild(bannuler);
        
        bok = document.createElement('button');
        bok.setAttribute('id', 'ok');
        bok.setAttribute('type', 'submit');
        bok.appendChild(document.createTextNode(Messages.get("OK")));
        div_boutons.appendChild(bok);
        
        formulaire.appendChild(div_boutons);
        div.appendChild(formulaire);
    }
    div_overlay = document.getElementById('div-overlay-filtre');
    div_overlay.style.display = 'block';
    tf[0][0].select();
}

FiltreDlg.prototype.annuler = function() {
    this.filtre = null;
    this.continuer();
}

FiltreDlg.prototype.valider = function() {
    var j, i;
    
    this.filtre = Traitement.tableau2D(this.dim, this.dim);
    for (j=0; j<this.dim; j++) {
        for (i=0; i<this.dim; i++) {
            this.filtre[i][j] = parseFloat(tf[i][j].value);
            if (isNaN(this.filtre[i][j])) {
                tf[i][j].focus();
                tf[i][j].select();
                return;
            }
        }
    }
    this.continuer();
}

FiltreDlg.prototype.continuer = function() {
    var div_overlay;
    
    div_overlay = document.getElementById('div-overlay-filtre');
    div_overlay.style.display = 'none';
    this.fct_suite(this.filtre);
    
}
